#! /bin/bash
if [ -f /sysroot/var/tmp/overlayfs ];then
	rm -rf /sysroot/var/tmp/overlayfs
fi

ROOT_RO=""
ROOT_RW=""
GET_ARG() {
for i in $(cat /proc/cmdline)
do
        echo $i|grep "root=" > /dev/null
        if [ $? -eq 0 ];then
                ROOT_RO="${i##root=}"
        fi
        echo $i|grep "root_rw=" > /dev/null
        if [ $? -eq 0 ];then
                ROOT_RW="${i##root_rw=}"
        fi
        if [ -n "$ROOT_RO" -a -n "$ROOT_RW" ];then
                break
        fi

done
}

GET_ARG

echo $ROOT_RO
echo $ROOT_RW

if [ -z "$ROOT_RW" ]
then
    echo "ROOT_RW is null, skip overlay ..."
    exit 0
fi

# mkdir sysroot_ro sysroot_rw # mount DEV1 & DEV3
umount -l $ROOT_RO
mkdir /sysroot_ro
mount $ROOT_RO /sysroot_ro -o ro


# clear DEV3
echo $ROOT_RW|grep 'UUID' >/dev/null
if [ $? -eq 0 ];then
    ROOT_RW_UUID="${ROOT_RW##UUID=}"
    ROOT_RW_DEV=$(blkid -U $ROOT_RW_UUID)
    /sbin/mkfs.ext4 -F -U $ROOT_RW_UUID $ROOT_RW_DEV
else
    ROOT_RW_UUID="$(blkid -s UUID $ROOT_RW |awk -F "\"" '{print $2}')"
    /sbin/mkfs.ext4 -F -U $ROOT_RW_UUID $ROOT_RW
fi

mkdir /sysroot_rw
mount $ROOT_RW /sysroot_rw -o rw
rm -rf /sysroot_rw/*
mkdir /sysroot_rw/{rw,work}
# mount -t tmpfs tmpfs /sysroot_rw
/sbin/depmod -a

# mount aufs with /dev/sda1 & /dev/sda6
#mount -t aufs -o br:/sysroot_rw=rw:/sysroot_ro=ro none /sysroot
touch /sysroot_rw/running
mount -t overlay overlay -olowerdir=/sysroot_ro,upperdir=/sysroot_rw/rw,workdir=/sysroot_rw/work /sysroot
touch /sysroot/var/tmp/overlayfs
chmod 777 /sysroot/var/tmp/overlayfs
list=`/usr/bin/ls /sysroot/home/`
for i in list
do
       /usr/bin/rm -rf /sysroot/home/$i/.local/share/gvfs-metadata/*
done
mkdir -p /sysroot/sysroot_rw /sysroot/sysroot_ro
chmod -R 755 /sysroot/sysroot_rw /sysroot/sysroot_ro

##################################
